Index: gui/graph_displayer_canvas-edge.cc
===================================================================
--- gui/graph_displayer_canvas-edge.cc	(revision 1596)
+++ gui/graph_displayer_canvas-edge.cc	(revision 1598)
@@ -23,5 +23,5 @@
 	  if(w>=0)
 	    {
-	      edgesmap[i]->property_width_pixels().set_value(w);
+	      edgesmap[i]->property_width_units().set_value(w);
 	    }
 	}
@@ -32,5 +32,5 @@
       if(w>=0)
 	{
-	  edgesmap[edge]->property_width_pixels().set_value(w);
+	  edgesmap[edge]->property_width_units().set_value(w);
 	}
     }
Index: gui/graph_displayer_canvas-event.cc
===================================================================
--- gui/graph_displayer_canvas-event.cc	(revision 1597)
+++ gui/graph_displayer_canvas-event.cc	(revision 1598)
@@ -590,5 +590,5 @@
 		    entry_coos.y-=edgetextmap[active_edge]->property_text_height().get_value()*1.5/2;
 		    canvasentrywidget=new Gnome::Canvas::Widget(displayed_graph, entry_coos.x, entry_coos.y, entrywidget);
-		    canvasentrywidget->property_width().set_value(edgetextmap[active_edge]->property_text_width().get_value()*1.5);
+		    canvasentrywidget->property_width().set_value(edgetextmap[active_edge]->property_text_width().get_value()*4);
 		    canvasentrywidget->property_height().set_value(edgetextmap[active_edge]->property_text_height().get_value()*1.5);
 		  }
@@ -768,8 +768,10 @@
 			edgetextmap[active_edge]->property_text().set_value(ostr.str());
 			(*(mapstorage.edgemap_storage)[edgemap_to_edit])[active_edge]=mapvalue_d;
+			mapwin->updateEdge(active_edge);
 			break;
 		      case NODE_MAP_EDIT:
 			nodetextmap[active_node]->property_text().set_value(ostr.str());
 			(*(mapstorage.nodemap_storage)[nodemap_to_edit])[active_node]=mapvalue_d;
+			mapwin->updateNode(active_node);
 			break;
 		      default:
Index: gui/graph_displayer_canvas.cc
===================================================================
--- gui/graph_displayer_canvas.cc	(revision 1592)
+++ gui/graph_displayer_canvas.cc	(revision 1598)
@@ -33,5 +33,5 @@
     edgesmap[i]=new BrokenEdge(displayed_graph, coos, *this);
     *(edgesmap[i]) << Gnome::Canvas::Properties::fill_color("green");
-    edgesmap[i]->property_width_pixels().set_value(10);    
+    edgesmap[i]->property_width_units().set_value(10);    
     
     //initializing edge-text as well, to empty string
Index: gui/main_win.cc
===================================================================
--- gui/main_win.cc	(revision 1592)
+++ gui/main_win.cc	(revision 1598)
@@ -2,9 +2,6 @@
 
 MainWin::MainWin(const std::string& title, Graph & graph, CoordinatesMap & cm,
-    MapStorage & ms):mapwin("Map Setup", ms, gd_canvas),editwin("Editorial Window", gd_canvas),newmapwin("Creating new map",gd_canvas),gd_canvas(graph, cm, ms, &mapwin)
+    MapStorage & ms):mapwin("Map Setup", ms, gd_canvas),newmapwin("Creating new map",gd_canvas),gd_canvas(graph, cm, ms, &mapwin)
 {
-  //Creating a window for setting new maps.
-//   newmapwin=new NewMapWi("Creating new map",*this);
-
 
   set_title (title);
@@ -24,5 +21,5 @@
       sigc::mem_fun(*this, &MainWin::saveFileAs));
   ag->add( Gtk::Action::create("FileQuit", Gtk::Stock::QUIT),
-      sigc::mem_fun(*this, &MainWin::quit));
+      sigc::mem_fun(*this, &MainWin::hide));
 
   ag->add( Gtk::Action::create("ViewMenu", "_View") );
@@ -38,7 +35,5 @@
   ag->add( Gtk::Action::create("ShowMenu", "_Show") );
   ag->add( Gtk::Action::create("ShowMaps", "_Maps"),
-      sigc::mem_fun(*this, &MainWin::showMaps));
-  ag->add( Gtk::Action::create("ShowEditorials", "_Editorials"),
-      sigc::mem_fun(*this, &MainWin::showEditorials));
+      sigc::mem_fun(this->mapwin, &MapWin::show));
 
   ag->add( Gtk::Action::create("CreateNode", Gtk::Stock::NO),
@@ -82,5 +77,4 @@
       "    <menu action='ShowMenu'>"
       "      <menuitem action='ShowMaps'/>"
-      "      <menuitem action='ShowEditorials'/>"
       "    </menu>"
       "  </menubar>"
@@ -133,19 +127,4 @@
 }
 
-void MainWin::showMaps()
-{
-  mapwin.show();
-}
-
-void MainWin::showEditorials()
-{
-  editwin.show();
-}
-
-void MainWin::quit()
-{
-  hide();
-}
-
 void MainWin::newFile()
 {
Index: gui/main_win.h
===================================================================
--- gui/main_win.h	(revision 1592)
+++ gui/main_win.h	(revision 1598)
@@ -8,5 +8,4 @@
 #include <map_win.h>
 #include <new_map_win.h>
-#include <edit_win.h>
 #include <libgnomecanvasmm.h>
 #include <libgnomecanvasmm/polygon.h>
@@ -28,7 +27,4 @@
   MapWin mapwin;
 
-  ///Window of editorial tools. Its type is \ref EditWin
-  EditWin editwin;
-
   ///We need to store newmapwin, to be able to set the appropriate values for properties of new map.
   NewMapWin newmapwin;
@@ -46,8 +42,4 @@
   Gtk::VBox vbox;
 
-  ///This function makes map-setup window popped up.
-  virtual void showMaps();
-  ///This function makes editorial window popped up.
-  virtual void showEditorials();
   ///Callback for 'FileNew' action.
   virtual void newFile();
@@ -58,6 +50,4 @@
   ///Callback for 'FileSaveAs' action.
   virtual void saveFileAs();
-  ///Callback for 'Quit' action.
-  virtual void quit();
 };
 