Index: gui/all_include.h
===================================================================
--- gui/all_include.h	(revision 1599)
+++ gui/all_include.h	(revision 1643)
@@ -41,4 +41,5 @@
 typedef Graph::NodeMap<Coordinates> CoordinatesMap;
 typedef Graph::Node Node;
+typedef Graph::Edge Edge;
 typedef Graph::EdgeIt EdgeIt;
 typedef Graph::NodeIt NodeIt;
Index: gui/graph_displayer_canvas-edge.cc
===================================================================
--- gui/graph_displayer_canvas-edge.cc	(revision 1632)
+++ gui/graph_displayer_canvas-edge.cc	(revision 1643)
@@ -4,5 +4,5 @@
 
 
-int GraphDisplayerCanvas::changeEdgeWidth (std::string mapname, Graph::Edge edge)
+int GraphDisplayerCanvas::changeEdgeWidth (std::string mapname, Edge edge)
 {
   Graph::EdgeMap<double> * actual_map;
@@ -50,5 +50,5 @@
 };
 
-int GraphDisplayerCanvas::changeEdgeColor (std::string mapname, Graph::Edge edge)
+int GraphDisplayerCanvas::changeEdgeColor (std::string mapname, Edge edge)
 {  
 
@@ -117,5 +117,5 @@
 };
 
-int GraphDisplayerCanvas::changeEdgeText (std::string mapname, Graph::Edge edge)
+int GraphDisplayerCanvas::changeEdgeText (std::string mapname, Edge edge)
 {
   //the number in the map will be written on the edge
Index: gui/graph_displayer_canvas-event.cc
===================================================================
--- gui/graph_displayer_canvas-event.cc	(revision 1632)
+++ gui/graph_displayer_canvas-event.cc	(revision 1643)
@@ -226,5 +226,5 @@
       isbutton=1;
 
-      active_node=NodeIt(mapstorage.graph,mapstorage.graph.addNode());
+      active_node=mapstorage.graph.addNode();
 
       //initiating values corresponding to new node in maps
@@ -340,5 +340,5 @@
 	      window_to_world (e->button.x, e->button.y, clicked_x, clicked_y);
 	      target_item=(get_item_at(clicked_x, clicked_y));
-	      Graph::NodeIt target_node=INVALID;
+	      Node target_node=INVALID;
 	      for (NodeIt i(mapstorage.graph); i!=INVALID; ++i)
 		{
@@ -355,12 +355,15 @@
           mapstorage.modified = true;
 
-		      *(nodesmap[target_node]) << Gnome::Canvas::Properties::fill_color("red");
+		      *(nodesmap[target_node]) <<
+			Gnome::Canvas::Properties::fill_color("red");
 
 		      //creating new edge
-		      active_edge=EdgeIt(mapstorage.graph,mapstorage.graph.addEdge(active_node, target_node));
+		      active_edge=mapstorage.graph.addEdge(active_node,
+							   target_node);
 
 		      //initiating values corresponding to new edge in maps
 		      mapstorage.initMapsForEdge(active_edge);
-                      (*mapstorage.edgemap_storage["id"])[active_edge] = mapstorage.graph.id(active_edge);
+                      (*mapstorage.edgemap_storage["id"])[active_edge] = 
+			mapstorage.graph.id(active_edge);
 	  
 		      //calculating coordinates of new edge
@@ -556,5 +559,5 @@
 	  {
 	    //for determine, whether it was an edge
-	    Graph::EdgeIt clicked_edge=INVALID;
+	    Edge clicked_edge=INVALID;
 
 	    //find the activated item between texts
@@ -678,5 +681,5 @@
 	  {
 	    //for determine, whether it was a node
-	    Graph::NodeIt clicked_node=INVALID;
+	    Node clicked_node=INVALID;
 
 	    //find the activated item between texts
@@ -850,5 +853,5 @@
 }
 
-void GraphDisplayerCanvas::deleteItem(NodeIt node_to_delete)
+void GraphDisplayerCanvas::deleteItem(Node node_to_delete)
 {
   delete(nodetextmap[node_to_delete]);
@@ -857,5 +860,5 @@
 }
 
-void GraphDisplayerCanvas::deleteItem(EdgeIt edge_to_delete)
+void GraphDisplayerCanvas::deleteItem(Edge edge_to_delete)
 {
   delete(edgetextmap[edge_to_delete]);
@@ -864,11 +867,4 @@
 }
 
-void GraphDisplayerCanvas::deleteItem(Graph::Edge edge_to_delete)
-{
-  delete(edgetextmap[edge_to_delete]);
-  delete(edgesmap[edge_to_delete]);
-  mapstorage.graph.erase(edge_to_delete);
-}
-
 void GraphDisplayerCanvas::textReposition(xy<double> new_place)
 {
Index: gui/graph_displayer_canvas-node.cc
===================================================================
--- gui/graph_displayer_canvas-node.cc	(revision 1632)
+++ gui/graph_displayer_canvas-node.cc	(revision 1643)
@@ -4,5 +4,5 @@
 
 
-int GraphDisplayerCanvas::changeNodeRadius (std::string mapname, Graph::Node node)
+int GraphDisplayerCanvas::changeNodeRadius (std::string mapname, Node node)
 {
   Graph::NodeMap<double> * actual_map;
@@ -70,5 +70,5 @@
 };
 
-int GraphDisplayerCanvas::changeNodeColor (std::string mapname, Graph::Node node)
+int GraphDisplayerCanvas::changeNodeColor (std::string mapname, Node node)
 {  
 
@@ -142,5 +142,5 @@
 };
 
-int GraphDisplayerCanvas::changeNodeText (std::string mapname, Graph::Node node)
+int GraphDisplayerCanvas::changeNodeText (std::string mapname, Node node)
 {
 
Index: gui/graph_displayer_canvas.h
===================================================================
--- gui/graph_displayer_canvas.h	(revision 1614)
+++ gui/graph_displayer_canvas.h	(revision 1643)
@@ -24,25 +24,25 @@
   ///Changes the linewidth attribute according to the given map.
   ///\param mapname is the name of the map which contains the new values
-  int changeEdgeWidth (std::string mapname, Graph::Edge new_item=INVALID);
+  int changeEdgeWidth (std::string mapname, Edge new_item=INVALID);
 
   ///Changes the linecolor attribute according to the given map.
   ///\param mapname is the name of the map which contains the new values
-  int changeEdgeColor (std::string mapname, Graph::Edge new_item=INVALID);
+  int changeEdgeColor (std::string mapname, Edge new_item=INVALID);
 
   ///Changes the text of line attribute according to the given map.
   ///\param mapname is the name of the map which contains the new values
-  int changeEdgeText (std::string mapname, Graph::Edge new_item=INVALID);
+  int changeEdgeText (std::string mapname, Edge new_item=INVALID);
 
   ///Changes the linewidth attribute according to the given map.
   ///\param mapname is the name of the map which contains the new values
-  int changeNodeRadius (std::string mapname, Graph::Node new_item=INVALID);
+  int changeNodeRadius (std::string mapname, Node new_item=INVALID);
 
   ///Changes the linecolor attribute according to the given map.
   ///\param mapname is the name of the map which contains the new values
-  int changeNodeColor (std::string mapname, Graph::Node new_item=INVALID);
+  int changeNodeColor (std::string mapname, Node new_item=INVALID);
 
   ///Changes the text of line attribute according to the given map.
   ///\param mapname is the name of the map which contains the new values
-  int changeNodeText (std::string mapname, Graph::Node new_item=INVALID);
+  int changeNodeText (std::string mapname, Node new_item=INVALID);
 
   ///Callback for 'ViewZoomIn' action.
@@ -120,9 +120,7 @@
 private:
   ///Deletes the given element.
-  void deleteItem(NodeIt);
+  void deleteItem(Node);
   ///Deletes the given element.
-  void deleteItem(EdgeIt);
-  ///Deletes the given element.
-  void deleteItem(Graph::Edge);
+  void deleteItem(Edge);
 
 private:
@@ -167,7 +165,7 @@
   ///2. we would like to handle only ony item per movement, therefore quering it is not a working solution
   Gnome::Canvas::Item * active_item, * target_item;
-  Graph::NodeIt active_node;
-  Graph::EdgeIt active_edge;
-  Graph::EdgeIt forming_edge;
+  Node active_node;
+  Edge active_edge;
+  Edge forming_edge;
 
   std::string nodemap_to_edit, edgemap_to_edit;
Index: gui/map_win.cc
===================================================================
--- gui/map_win.cc	(revision 1606)
+++ gui/map_win.cc	(revision 1643)
@@ -218,5 +218,5 @@
 };
 
-void MapWin::updateNode(Graph::Node node)
+void MapWin::updateNode(Node node)
 {
   for(int i=0;i<NODE_PROPERTY_NUM;i++)
@@ -251,5 +251,5 @@
 }
 
-void MapWin::updateEdge(Graph::Edge edge)
+void MapWin::updateEdge(Edge edge)
 {
   for(int i=0;i<EDGE_PROPERTY_NUM;i++)
Index: gui/mapstorage.cc
===================================================================
--- gui/mapstorage.cc	(revision 1634)
+++ gui/mapstorage.cc	(revision 1643)
@@ -117,5 +117,5 @@
 }
 
-void MapStorage::initMapsForEdge(Graph::Edge e)
+void MapStorage::initMapsForEdge(Edge e)
 {
   std::map< std::string,Graph::EdgeMap<double> * >::iterator ems_it;
Index: lemon/concept/graph.h
===================================================================
--- lemon/concept/graph.h	(revision 1631)
+++ lemon/concept/graph.h	(revision 1643)
@@ -405,5 +405,5 @@
         /// This constructor sets the iterator to the first edge of \c g.
         ///@param g the graph
-        EdgeIt(const StaticGraph& g) { }
+        EdgeIt(const StaticGraph& g) { ignore_unused_variable_warning(g); }
         /// Edge -> EdgeIt conversion
 
Index: lemon/concept/path.h
===================================================================
--- lemon/concept/path.h	(revision 1624)
+++ lemon/concept/path.h	(revision 1643)
@@ -25,4 +25,5 @@
 
 #include <lemon/invalid.h>
+#include <lemon/concept_check.h>
 
 namespace lemon {
@@ -55,5 +56,7 @@
       /// \param _g The graph in which the path is.
       ///
-      Path(const Graph &_g) {}
+      Path(const Graph &_g) {
+	ignore_unused_variable_warning(_g);
+      }
 
       /// Length of the path.
Index: lemon/concept/undir_graph.h
===================================================================
--- lemon/concept/undir_graph.h	(revision 1631)
+++ lemon/concept/undir_graph.h	(revision 1643)
@@ -558,5 +558,5 @@
         /// This constructor sets the iterator to the first edge of \c g.
         ///@param g the graph
-        EdgeIt(const UndirGraph &g) { }
+        EdgeIt(const UndirGraph &g) { ignore_unused_variable_warning(g); }
         /// Edge -> EdgeIt conversion
 
@@ -606,5 +606,8 @@
         ///@param n the node
         ///@param g the graph
-        OutEdgeIt(const UndirGraph& n, const Node& g) { }
+        OutEdgeIt(const UndirGraph& n, const Node& g) {
+	  ignore_unused_variable_warning(n);
+	  ignore_unused_variable_warning(g);
+	}
         /// Edge -> OutEdgeIt conversion
 
@@ -655,5 +658,8 @@
         ///@param n the node
         ///@param g the graph
-        InEdgeIt(const UndirGraph& g, const Node& n) { }
+        InEdgeIt(const UndirGraph& g, const Node& n) { 
+	  ignore_unused_variable_warning(n);
+	  ignore_unused_variable_warning(g);
+	}
         /// Edge -> InEdgeIt conversion
 
Index: lemon/full_graph.h
===================================================================
--- lemon/full_graph.h	(revision 1566)
+++ lemon/full_graph.h	(revision 1643)
@@ -126,8 +126,8 @@
     protected:
       int id;
-      Node(int _id) { id = _id;}
+      Node(int _id) : id(_id) {}
     public:
       Node() {}
-      Node (Invalid) { id = -1; }
+      Node (Invalid) : id(-1) {}
       bool operator==(const Node node) const {return id == node.id;}
       bool operator!=(const Node node) const {return id != node.id;}
@@ -261,10 +261,10 @@
     Node source(Edge e) const { 
       /// \todo we may do it faster
-      return ((int)sqrt((double)(1 + 8 * e.id)) + 1) / 2; 
+      return Node(((int)sqrt((double)(1 + 8 * e.id)) + 1) / 2);
     }
 
     Node target(Edge e) const { 
       int source = ((int)sqrt((double)(1 + 8 * e.id)) + 1) / 2;;
-      return e.id - (source) * (source - 1) / 2; 
+      return Node(e.id - (source) * (source - 1) / 2);
     }
 